#!/bin/sh
#
# wakame-ebs-mysql-master-make-snapshot.sh
#
# description: gihyo.jpLpWakameXNvg
# author: masahito@axsh.net
# see also: http://wakame.axsh.jp/
#

## ʐݒ
pwd=$(cd $(dirname $0) && pwd)
[ -f ${pwd}/_wakame-common.sh ] && . ${pwd}/_wakame-common.sh

# tς݂volume-id擾
ebs_master_volume=$(ec2-describe-volumes | grep ${ec2_instance_id} | grep ${ebs_master_dev} | grep attached | awk '{print $2}')
[ -z "${ebs_master_volume}" ] && { echo not mounted: ${ebs_master_dev}; exit 1; }
echo volume-id:${ebs_master_volume}
echo

# MySQL Masterւ̐ڑmF
echo "SHOW MASTER STATUS" | mysql_command >/dev/null || {exit 1;}

# XibvVbg̓f[^XVȂlɃe[ubN
echo "... flush tables with read lock;";
echo "FLUSH TABLES WITH READ LOCK;" | mysql_command

# MySQL Master̃|WV擾
echo "... show master status;";
mysqld_master_status=$(echo "SHOW MASTER STATUS;" | mysql_command)
set ${mysqld_master_status}
mysqld_master_binlog_file=$1
mysqld_master_binlog_pos=$2

# MySQL Slavepmaster.info𐶐
# master.infóu14sv̂ŁAr̋sɂӖ܂
echo "... make master.info"
cat <<EOS > ${mysqld_master_dir}/master.info
14
${mysqld_master_binlog_file}
${mysqld_master_binlog_pos}
${mysqld_master_info_host}
${mysqld_master_info_user}
${mysqld_master_info_pass}
${mysqld_master_info_port}
60
0





EOS

# master.infot@C̃I[i[mysql[U[֕ύX
chmod 0644        ${mysqld_master_dir}/master.info
chown mysql:mysql ${mysqld_master_dir}/master.info

# MySQL MasterpdatadirAmazon EBS Snapshot𐶐
echo "$ ec2-create-snapshot ${ebs_master_volume}"
ebs_master_snapshot_id=$(ec2-create-snapshot ${ebs_master_volume} | awk '{print $2}')
[ -z "${ebs_master_snapshot_id}" ] && { exit 1; }

# Amazon EBS SnapshotI܂Őbsleep
for i in 1 2 3 4 5 6 7 8 9 10; do
  echo -n ". "
  ec2-describe-snapshots | grep ${ebs_master_snapshot_id} | grep completed -q && break
  sleep 1
done
echo

# Amazon EBS SnapshotAe[ubN
echo "... unlock tables;";
echo "UNLOCK TABLES;" | mysql_command

# MySQL Slavedatadirpsnapshot-ido
echo ">>> snapshot_id = ${ebs_master_snapshot_id}"

exit 0
